//
// Fragment shader for drawing water for R2VB water demo
//

uniform	sampler3D	noiseMap;
uniform samplerCube	reflectionMap;
uniform	float		time;
varying vec3		n;
varying	vec3		v;

void	main ()
{
	const vec4	c1 = vec4 ( 0.0, 0.4, 0.3, 1.0 );
	const vec4	c2 = vec4 ( 0.0, 0.3, 0.7, 1.0 );

	vec3	nn = normalize ( n );
	vec3	vn = normalize ( v );
    vec3	r  = reflect   ( vn, nn );
	float	ca = dot       ( vn, nn );
    
    					// Do a lookup into the environment map.
    vec4 envColor   = textureCube ( reflectionMap, r.zyx );
	vec4 waterColor = mix         ( c1, c2, ca );

    					// calc fresnels term.  This allows a view dependant
    					// blend of reflection/refraction
    float fresnel = clamp ( ca, 0.1, 0.9 );
	

	gl_FragColor = mix ( waterColor, envColor, fresnel );
}
